#include	<stdio.h>
#include        "386.c"
#include        "approxVM.cpp"
#include	<string.h>
#include        <io.h>
#include        <unistd.h>
#include        <fcntl.h>
#include        <iostream.h>

char *buf;
char *wbuf;

extern int hz;

main(int argc, char *argv[])
{
	int c;
	extern char *optarg;
	extern int optind;

	int kval=1;
	int sval=0;
	int npreproc = 1;
	int nexec = 1;
        int alg = 1;
        int pp_r = 1;
        int r=1;
        int pp_lastr;
        int nindex = 1;
        int i;

	long tp, te, nf, ti;
	int nw;
	int nbuf, len;
	char *s;

	while((c = getopt(argc, argv, "k:s:e:p:a:r:i:")) != -1)
		switch(c)
		{
		case 'k':	kval = atoi(optarg); break;
		case 's':	sval = atoi(optarg); break;
		case 'p':	npreproc = atoi(optarg); break;
		case 'e':	nexec = atoi(optarg); break;
                case 'a':	alg = atoi(optarg); break;
                case 'r':	pp_r = atoi(optarg); break;
                case 'i':       nindex = atoi(optarg); break;
		default:	goto usage;
		}
	if((optind >= argc) || (optind+2 < argc)){
usage:
		fprintf(stderr, "usage: %s [-k err] [-s sil] [-e nex] [-p npp] [-a alg] [-r npp][string] file\n", argv[0]);
		exit(1);
	}
	if((c = open(argv[argc-1], O_BINARY)) < 0){
		perror(argv[argc-1]);
		exit(1);
	}
        buf = (char *)malloc((filelength(c)+1027)*sizeof(char));

	nbuf = read(c, buf+1, filelength(c)*sizeof(char));
	buf[++nbuf] = '#';
	buf[nbuf+1] = '\0';
	close(c);
	if(optind+2 == argc){
		len = strlen(argv[optind]);
                wbuf = (char *)malloc((len+3)*sizeof(char));
		strcpy(wbuf, argv[optind]);
		wbuf[len] = '\0';
		wbuf[len+1] = '\0';
	} else {
                wbuf = (char*)malloc(100*sizeof(char));
                i = 0;
		while((c = getchar()) != EOF) {
			wbuf[i++] = (c=='\n')? '\0':c;
                        if ((98+i) % 98 == 0)
                           wbuf = (char*)realloc(wbuf,i*2*sizeof(char));
                }
		wbuf[i++] = '\0'; wbuf[i] = '\0';
	}
	tp = te = ti = 0;
	nf = nw = 0;
        startclock();
	for(c = 0; c < nindex; c++)
           index(buf+1, nbuf, alg, !sval);
        ti += stopclock();
        if (pp_r == -2) {
           r=1;
           pp_lastr = kval+1;
        }
        else if (pp_r == -1 || pp_r == 0) {
           r = CalcOptPart(nbuf,strlen(wbuf),kval,pp_r,wbuf);
           pp_lastr = r;
        }
        else {
           r = pp_r;
           pp_lastr = pp_r;
        }
        for (;r<=pp_lastr;r++) {
   	   for(s = wbuf; s[0] != '\0';) {
	   	nw++;
		len = strlen(s);
		startclock();
		for(c = 0; c < npreproc; c++)
			prep(s, len, alg, r, kval, !sval);
		tp += stopclock();
		startclock();
		for(c = 0; c < nexec; c++)
			nf += exec(buf+1, nbuf, alg, r, kval, !sval);
		te += stopclock();
		s += len;
		/* skip a possible empty word */
		if (s[0] == '\0') s++;
   	   }
      	   printf("alg=%s a=%d k=%d s=%d r=%d np=%d match=%ld \n i=%4fs p=%.4fs(%ld/%d) e=%.4fs(%ld/%d)\n",
                argv[0], alg, kval, sval, r, nw, (long)nf/nexec,
                (ti*1.0)/(hz*nindex),
		(tp*1.0)/(hz*npreproc), tp, npreproc,
		(te*1.0)/(hz*nexec), te, nexec);
           tp = 0;
           te = 0;
           nf = 0;
           nw = 0;
        }
	exit(0);
}

